//****************************************************************
// O[o萔
// (BAVCf[^邱ƂłƂ)
//****************************************************************

float4x4 mW;		// [hsiL̍sj
float4x4 mV;		// r[siJj
float4x4 mP;		// ˉe(2D)ϊs

//------------------------------------------------
// }eA֌W
float4 MateDiffuse = float4(1, 1, 1, 1);	// }eAF il͔j
texture MateDiffuseTex;						// }eÃeNX`
sampler MateDiffuseSmp = sampler_state {	// MateDiffuseTex pTv
	Texture = <MateDiffuseTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};
float4 MateSpecular = float4(1, 1, 1, 1);	// ގ̔˗
float  MateSpePower = 50;					// ˂̉s(ׂ̒l)
float4 MateEmissive;						// ȏƖ

//------------------------------------------------
// Cg֌W
float4 DLightColor = float4(1, 1, 1, 1);		// Cg̐F
float4 DLightSpecular = float4(1, 1, 1, 1);	// ˌ̐F
float3 DLightDir = float3(0, -1, 0);			// sCg̕
float4 DLightAmbient;						// 

float4 PLightColor = float4(1, 1, 1, 1);		// Cg̐F
float4 PLightSpecular = float4(1, 1, 1, 1);	// ˌ̐F
float3 PLightPos = float3(0, 10, 0);			// sCg̕
float4 PLightAmbient;						// 
float  PLightAttenuation[3];				// 

//------------------------------------------------
// J֌W
float3 CamPos;		// JW

//------------------------------------------------
// gD[
texture ToonTex;						// AepeNX`
sampler ToonSmp = sampler_state {		// AepTv
	Texture = <ToonTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

//------------------------------------------------
// ֊spf[^
float4 OutlineColor;		// ֊s̐F
float  OutlineSize;			// ֊s̑

//------------------------------------------------
// }bsO֌W
float RefPower = 0.5f;		// f荞ݗ
texture CubeTex;
samplerCUBE CubeSmp = sampler_state {
	Texture = <CubeTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

//------------------------------------------------
// tHO֌W
float4 FogColor = float4(1,1,1,1);		// tHO̐F
float FogNear = 0.0f;	// tHO̊Jnʒu
float FogFar = 1.0f;	// tHȌIʒu


//***************************************************************
// _VF[_o͗p
//***************************************************************
struct VS_OUT {
	float4 Pos	  : POSITION;		// ˉeiQcjW
	float3 wN     : TEXCOORD0;		// [h@
	float2 MeshUV : TEXCOORD1;		// tuW
	float3 wPos   : TEXCOORD2;		// RcW
};

//===========================================
// _VF[_
//===========================================
VS_OUT VS(	float4 pos		: POSITION,		// _W
			float3 normal	: NORMAL,		// @xNg
			float2 mesh_uv	: TEXCOORD0)	// tuW
{
	VS_OUT Out;		// o͗p_{[

	// ˉeiQcjϊ
	Out.Pos = mul(pos, mW);			// L̍sŕϊij
	Out.wPos = Out.Pos.xyz;			// RcWĂ
	Out.Pos = mul(Out.Pos, mV);		// J̍sŕϊ
	Out.Pos = mul(Out.Pos, mP);		// ˉeiQcj֕ϊ

	// [h@ ˉeϊĂ K
	Out.wN = mul(normal, (float3x3)mW);
	Out.wN = normalize(Out.wN);

	Out.MeshUV = mesh_uv;

	return Out;
}



//*************************************************************
// sNZVF[_o͗p
//*************************************************************
struct PS_OUT {
	float4 Color	: COLOR0;
	float4 Bloom	: COLOR1;	// PxF
};

//===========================================
// sNZVF[_
//===========================================
PS_OUT PS(VS_OUT In)
{
	float3 w_normal = normalize(In.wN);			// @̐K
	float3 vCam = normalize(CamPos - In.wPos);	// Jւ̕


	//--------------------------------
	// fF
	//--------------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);
	float4 modelCol = MateDiffuse * texCol;
	// ------ }bsO --------
	float3 vRefDir = reflect(-vCam, w_normal);					// ˃xNg
	float4 envCol = texCUBE(CubeSmp, vRefDir);					// L[ueNX`F
	modelCol.rgb = lerp(modelCol.rgb, envCol.rgb, RefPower);	// F̍

	//--------------------------------
	// CgF
	//--------------------------------
	float4 lightCol = float4(1, 1, 1, 1);
	
	// ------gU-------
	// sCeBOio[gj
	float LPowDir = dot(-DLightDir, w_normal);
	LPowDir = saturate(LPowDir);

	// ------_---------
	float3 dir;
	dir = float3(mW._41, mW._42, mW._43) - PLightPos.xyz;
	float len;
	len = length(dir);
	dir = dir / len;
	float LPowPoint;
	LPowPoint = saturate(dot(-dir, normalize(w_normal)));
	LPowPoint = LPowPoint * saturate(1.0f / (PLightAttenuation[0] + PLightAttenuation[1]*len + PLightAttenuation[2]*len*len));

	// ToonTex F擾
	float4 toonCol = tex2D(ToonSmp, float2(LPowDir, 0));
	//float4 toonCol = tex2D(ToonSmp, float2(LPowDir + LPowPoint, 0));
	lightCol.rgb += DLightColor.rgb * toonCol.rgb;

	// 
	lightCol.rgb += DLightAmbient.rgb;

	// ------ˌ--------
	float4 lightSpe = 0;
	float3 vRef = reflect(DLightDir, w_normal);	// ˂ꂽ̕
	float SPow = dot(vRef, vCam);				// ܂Ԃ
	SPow = saturate(SPow);						// O`P
	SPow = pow(SPow, MateSpePower);				// ܂Ԃ̒
	lightSpe += DLightSpecular * SPow;			

	// ------tHOvZ--------
	float3 disVec = CamPos - In.wPos;
	float  dis = length(disVec);
	float f = (FogFar - dis) / (FogFar - FogNear);
	f = clamp(f, 0.0f, 1.0f);
	float4 fogCol = -FogColor * (1.0f - f);

	
	//--------------------------------
	// Fo
	//--------------------------------
	float4 diffuseCol = modelCol * lightCol;	// gUF
	float4 speCol = lightSpe * MateSpecular;	// ŏIIȌ̐F
	PS_OUT Out;
	Out.Color = diffuseCol;
	Out.Color.rgb += fogCol.rgb; 
	Out.Color.rgb += speCol.rgb;
	Out.Color.rgb += MateEmissive.rgb * 1.0f;
	

	Out.Bloom.rgb = max(0, Out.Color.rgb - 1);	// 傫قԂi0菬0Ԃj
	Out.Bloom.a = 1;

	return Out;
}



//***************************************************************
// eNjbN@i_VF[_ƃsNZVF[_킹́j
//		Q[vOŃVF[_gꍇ͂g
//***************************************************************
technique Tech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();		// _VF[_VS()g
		PixelShader  = compile ps_3_0 PS();		// sNZVF[_PS()g
	}
}


//***************************************************************
//
// ֊sVF[_
//
//***************************************************************

//***************************************************************
// OutlineVS @֊sp@_VF[_
//***************************************************************

//===========================================
// f[^o͗p
//===========================================
struct OutlineVS_OUT {
	float4 Pos:POSITION;
};

//===========================================
// _VF[_
//===========================================
OutlineVS_OUT OutlineVS(float4 pos:POSITION,		// _̃[JW
						float3 normal:NORMAL)		// [J@
{
	OutlineVS_OUT Out;

	// pos  normal ɂ炷
	pos.xyz += normal * OutlineSize;

	// Qciˉejϊ
	Out.Pos = mul(pos, mW);
	Out.Pos = mul(Out.Pos, mV);
	Out.Pos = mul(Out.Pos, mP);
	return Out;
}

//***************************************************************
// OutlinePS @֊sp@sNZVF[_
//***************************************************************

//===========================================
// sNZVF[_
//===========================================
float4 OutlinePS(OutlineVS_OUT In):COLOR0
{
	return OutlineColor;
}


//***************************************************************
// OutlineTech  ֊sp@eNjbN
//***************************************************************
technique OutlineTech {
	pass P0 {
		VertexShader = compile vs_3_0 OutlineVS();
		PixelShader  = compile ps_3_0 OutlinePS();
		CullMode = CW;		// JO[hbvɁiʕ`j
	}
}